SELECT
     
    EELP.CODIGO || '.' || OEPMP.CODIGO || '.' || MPMP.CODIGO || '. ' || MPMP.DESCRIPCION    AS META_PMP,
    XE.ID_ACCION_ESTRATEGICA                                                                AS ID_ACCION_ESTRATEGICA,
    XE.CODIGO   || '. '|| XE.DESCRIPCION                                                    AS ACCION_ESTRATEGICA,
    UE.CODIGO                                                                               AS CODIGO_UE,
    UE.NOMBRE                                                                               AS NOMBRE_UE,
    AE.ID_APORTE_ESTRATEGICO                                                                AS ID_APORTE_ESTRATEGICO,
    AE.CODIGO   || '.' ||  ' ' ||  AE.DESCRIPCION                                           AS APORTE_ESTRATEGICO,
    EP.PERIODO_ANUAL                                                                        as PERIODO_ANUAL,
    ROUND(D.AVANCE_ACUMULADO,2) AS AVANCE_ACUMULADO,
    ROUND(SUM(D.AVANCE_ACUMULADO) OVER(PARTITION BY XE.ID_ACCION_ESTRATEGICA),2) AS AVANCE_ACCION
    
FROM META_POA_EVALUACION MPE

    
INNER JOIN META_POA                     MP      ON MP.ID_META_POA = MPE.META_POA
INNER JOIN META_POA_APORTE              MPA     ON MPA.META_POA = MP.ID_META_POA
INNER JOIN APORTE_ESTRATEGICO           AE      ON AE.ID_APORTE_ESTRATEGICO = MPA.APORTE_ESTRATEGICO
INNER JOIN PLAN_APORTE_ESTRATEGICO      PAE     ON PAE.ID_PLAN_APORTE_ESTRATEGICO = AE.PLAN_APORTE_ESTRATEGICO
INNER JOIN UNIDAD_EJECUTORA             UE      ON UE.ID_UNIDAD_EJECUTORA = PAE.UNIDAD_EJECUTORA
INNER JOIN ACCION_ESTRATEGICA           XE      ON XE.ID_ACCION_ESTRATEGICA = AE.ACCION_ESTRATEGICA
INNER JOIN PLAN_ACCION_ESTRATEGICA      PXE     ON PXE.ID_PLAN_ACCION_ESTRATEGICA = XE.PLAN_ACCION_ESTRATEGICA
INNER JOIN META_PMP                     MPMP    ON MPMP.ID_META_PMP = XE.META_PMP
INNER JOIN DETALLE_PMP                  DPMP    ON DPMP.ID_DETALLE_PMP = MPMP.DETALLE_PMP
INNER JOIN EJE_ESTRATEGICO_PLP          EELP    ON EELP.ID_EJE_ESTRATEGICO_PLP = DPMP.EJE_ESTRATEGICO_LARGO_PLAZO
INNER JOIN PRIORIDAD_ESTRATEGICA_PMP    PEPMP   ON PEPMP.ID_PRIORIDAD_ESTRATEGICA_PMP = DPMP.PRIORIDAD_ESTRATEGICA_PMP
INNER JOIN OBJETIVO_ESTRATEGICO_PMP     OEPMP   ON OEPMP.ID_OBJETIVO_ESTRATEGICO_PMP = DPMP.OBJETIVO_ESTRATEGICO_PMP
INNER JOIN ETAPA_PLAN                   EP      ON (MPE.ETAPA_PLAN = EP.ID_ETAPA_PLAN)


LEFT JOIN (
        SELECT 
            APD.APORTE_ESTRATEGICO,
            CASE 
                WHEN ROUND(SUM((((1 / CAN_APO.CANTIDAD_APORTES) * APD.DISTRIBUCION_PORCENTUAL) * NVL(EJECUCION.PROMEDIO, 0)) / 100),2) = 0 
                    THEN 0.00
                ELSE ROUND(SUM((((1 / CAN_APO.CANTIDAD_APORTES) * APD.DISTRIBUCION_PORCENTUAL) * NVL(EJECUCION.PROMEDIO, 0)) / 100),2)
            END AS AVANCE_ACUMULADO
            
            FROM PERIODO_ANUAL PA
            INNER JOIN APORTE_PAE_DISTRIBUCION      APD  ON (APD.PERIODO_ANUAL = PA.ID_PERIODO_ANUAL)
            INNER JOIN APORTE_ESTRATEGICO           APE  ON (APE.ID_APORTE_ESTRATEGICO = APD.APORTE_ESTRATEGICO)
            INNER JOIN ACCION_ESTRATEGICA           ACE  ON (ACE.ID_ACCION_ESTRATEGICA = APE.ACCION_ESTRATEGICA)
            INNER JOIN (SELECT ACCION_ESTRATEGICA, COUNT(*) AS CANTIDAD_APORTES FROM PPI.APORTE_ESTRATEGICO GROUP BY ACCION_ESTRATEGICA) CAN_APO ON CAN_APO.ACCION_ESTRATEGICA = ACE.ID_ACCION_ESTRATEGICA
        
            LEFT JOIN(
                SELECT  
                        APD.APORTE_ESTRATEGICO, 
                        NVL(AVG(MPE.EJECUCION),0) PROMEDIO,
                        MPE.ETAPA_PLAN, 
                        PA.ANO, 
                        MAX(EP.FECHA_FINAL_EVALUACION) AS FECHA_FINAL_EVALUACION
                    FROM PERIODO_ANUAL                  PA
                    INNER JOIN APORTE_PAE_DISTRIBUCION  APD ON (APD.PERIODO_ANUAL       = PA.ID_PERIODO_ANUAL)
                    INNER JOIN META_POA_APORTE          MPA ON (MPA.APORTE_ESTRATEGICO  = APD.APORTE_ESTRATEGICO)
                    INNER JOIN META_POA_EVALUACION      MPE ON (MPE.META_POA            = MPA.META_POA)
                    INNER JOIN META_POA                 MP  ON (MP.ID_META_POA          = MPE.META_POA)
                    INNER JOIN OBJETIVO_POA             OP  ON (OP.ID_OBJETIVO_POA      = MP.OBJETIVO_POA)
                    INNER JOIN PLAN_OPERATIVO           PO  ON (PO.ID_PLAN_OPERATIVO    = OP.PLAN_OPERATIVO AND  PO.PERIODO_ANUAL = PA.ID_PERIODO_ANUAL)
                    INNER JOIN EVALUACION_OPERATIVA     EO  ON (EO.PLAN_OPERATIVO       = PO.ID_PLAN_OPERATIVO AND EO.ETAPA_PLAN = MPE.ETAPA_PLAN)
                    INNER JOIN ETAPA_PLAN               EP  ON (EP.ID_ETAPA_PLAN        = EO.ETAPA_PLAN)
                    WHERE 
                    PA.ID_PERIODO_ANUAL IN (SELECT DISTINCT PERIODO_ANUAL FROM APORTE_PAE_DISTRIBUCION)
                     GROUP BY PA.ANO, APD.APORTE_ESTRATEGICO, MPE.ETAPA_PLAN, EP.FECHA_FINAL_EVALUACION
                    ORDER BY APD.APORTE_ESTRATEGICO, PA.ANO ASC
                    
            ) EJECUCION ON (EJECUCION.ANO = PA.ANO AND EJECUCION.APORTE_ESTRATEGICO= APD.APORTE_ESTRATEGICO)
            WHERE 
            PA.ID_PERIODO_ANUAL IN (SELECT DISTINCT PERIODO_ANUAL FROM APORTE_PAE_DISTRIBUCION)
            GROUP BY APD.APORTE_ESTRATEGICO

) D ON D.APORTE_ESTRATEGICO = AE.ID_APORTE_ESTRATEGICO
WHERE 
PXE.UNIDAD_EJECUTORA = :unidadEjecutora 
AND MPE.ETAPA_PLAN = :etapaPlan
GROUP BY 
    EELP.CODIGO, 
    OEPMP.CODIGO, 
    MPMP.CODIGO, 
    MPMP.DESCRIPCION, 
    XE.ID_ACCION_ESTRATEGICA,
    XE.CODIGO, 
    XE.DESCRIPCION, 
    UE.CODIGO, 
    UE.NOMBRE, 
    AE.ID_APORTE_ESTRATEGICO,
    AE.CODIGO, 
    AE.DESCRIPCION,
    EP.PERIODO_ANUAL,
    D.AVANCE_ACUMULADO
ORDER BY 
    EELP.CODIGO, 
    OEPMP.CODIGO, 
    MPMP.CODIGO, 
    XE.CODIGO, 
    UE.CODIGO, 
    UE.NOMBRE, 
    AE.CODIGO,
    EP.PERIODO_ANUAL