SELECT 
    PEPMP.CODIGO        || '.' || PEPMP.DESCRIPCION                                                     AS PRIORIDAD_PMP,
    EP.PERIODO_ANUAL                                                                                    AS PERIODO_ANUAL,
    EJE.CODIGO        || '.' || PEPMP.CODIGO || '.' || MPMP.CODIGO || '.' || ' ' || MPMP.DESCRIPCION    AS META_PMP,
    ACE.CODIGO || '.' || ' ' || ACE.DESCRIPCION                                                         AS ACCION_ESTRATEGICA,
    AAU.NOMBRE                                                                                          AS NOMBRE_AMBITO,
    UE.NOMBRE                                                                              AS UNIDAD_EJECUTORA,
    NVL(AVANCE_ACCION.SUMA_AVANCE_X_ACCION,0)                                                           AS AVANCE_ACUMULADO
FROM META_PMP                           MPMP
INNER JOIN DETALLE_PMP                  DPMP    ON (DPMP.ID_DETALLE_PMP = MPMP.DETALLE_PMP)
INNER JOIN PRIORIDAD_ESTRATEGICA_PMP    PEPMP   ON (PEPMP.ID_PRIORIDAD_ESTRATEGICA_PMP = DPMP.PRIORIDAD_ESTRATEGICA_PMP)
INNER JOIN EJE_ESTRATEGICO_PLP          EJE     ON (EJE.ID_EJE_ESTRATEGICO_PLP = DPMP.EJE_ESTRATEGICO_LARGO_PLAZO)
INNER JOIN ENCARGADO_MONITOREO          EM      ON (EM.ID_ENCARGADO_MONITOREO = MPMP.ENCARGADO_MONITOREO)
INNER JOIN AMBITO_ACCION_UNIVERSITARIA  AAU     ON (AAU.ID_AMBITO_ACCION_UNIVERSITARIA = MPMP.AMBITO_ACCION_UNIVERSITARIA)
INNER JOIN OBJETIVO_ESTRATEGICO_PMP     OEPMP   ON (OEPMP.ID_OBJETIVO_ESTRATEGICO_PMP = DPMP.OBJETIVO_ESTRATEGICO_PMP)
INNER JOIN ACCION_ESTRATEGICA           ACE     ON (ACE.META_PMP = MPMP.ID_META_PMP)
INNER JOIN PLAN_ACCION_ESTRATEGICA      PACE    ON (PACE.ID_PLAN_ACCION_ESTRATEGICA = ACE.PLAN_ACCION_ESTRATEGICA)
INNER JOIN UNIDAD_EJECUTORA             UE      ON (UE.ID_UNIDAD_EJECUTORA = PACE.UNIDAD_EJECUTORA)

LEFT JOIN (
        SELECT 
            ACCIONES.ID_ACCION_ESTRATEGICA,
            ACCIONES.CODIGO,
            ACCIONES.DESCRIPCION,
            SUM(AVANCE_ACUMULADO) AS SUMA_AVANCE_X_ACCION,
            ACCIONES.ETAPA_PLAN
        FROM (
            SELECT 
                ACE.ID_ACCION_ESTRATEGICA,
                ACE.CODIGO,
                ACE.DESCRIPCION,
                EJECUCION.ETAPA_PLAN,
                CASE 
                    WHEN ROUND(SUM((((1 / CAN_APO.CANTIDAD_APORTES) * APD.DISTRIBUCION_PORCENTUAL) * NVL(EJECUCION.PROMEDIO, 0)) / 100),2) = 0 
                        THEN 0.00
                    ELSE ROUND(SUM((((1 / CAN_APO.CANTIDAD_APORTES) * APD.DISTRIBUCION_PORCENTUAL) * NVL(EJECUCION.PROMEDIO, 0)) / 100),2)
                END AS AVANCE_ACUMULADO
            
            FROM PERIODO_ANUAL PA
            INNER JOIN APORTE_PAE_DISTRIBUCION      APD  ON (APD.PERIODO_ANUAL = PA.ID_PERIODO_ANUAL)
            INNER JOIN APORTE_ESTRATEGICO           APE  ON (APE.ID_APORTE_ESTRATEGICO = APD.APORTE_ESTRATEGICO)
            INNER JOIN ACCION_ESTRATEGICA           ACE  ON (ACE.ID_ACCION_ESTRATEGICA = APE.ACCION_ESTRATEGICA)
            INNER JOIN (SELECT ACCION_ESTRATEGICA, COUNT(*) AS CANTIDAD_APORTES FROM PPI.APORTE_ESTRATEGICO GROUP BY ACCION_ESTRATEGICA) CAN_APO ON CAN_APO.ACCION_ESTRATEGICA = ACE.ID_ACCION_ESTRATEGICA
            
            LEFT JOIN(
                SELECT  
                        APD.APORTE_ESTRATEGICO, 
                        NVL(AVG(MPE.EJECUCION),0) PROMEDIO,
                        MPE.ETAPA_PLAN AS ETAPA_PLAN, 
                        PA.ANO, 
                        MAX(EP.FECHA_FINAL_EVALUACION) AS FECHA_FINAL_EVALUACION
                    FROM PERIODO_ANUAL                  PA
                    INNER JOIN APORTE_PAE_DISTRIBUCION  APD ON (APD.PERIODO_ANUAL       = PA.ID_PERIODO_ANUAL)
                    INNER JOIN META_POA_APORTE          MPA ON (MPA.APORTE_ESTRATEGICO  = APD.APORTE_ESTRATEGICO)
                    INNER JOIN META_POA_EVALUACION      MPE ON (MPE.META_POA            = MPA.META_POA)
                    INNER JOIN META_POA                 MP  ON (MP.ID_META_POA          = MPE.META_POA)
                    INNER JOIN OBJETIVO_POA             OP  ON (OP.ID_OBJETIVO_POA      = MP.OBJETIVO_POA)
                    INNER JOIN PLAN_OPERATIVO           PO  ON (PO.ID_PLAN_OPERATIVO    = OP.PLAN_OPERATIVO AND  PO.PERIODO_ANUAL = PA.ID_PERIODO_ANUAL)
                    INNER JOIN EVALUACION_OPERATIVA     EO  ON (EO.PLAN_OPERATIVO       = PO.ID_PLAN_OPERATIVO AND EO.ETAPA_PLAN = MPE.ETAPA_PLAN)
                    INNER JOIN ETAPA_PLAN               EP  ON (EP.ID_ETAPA_PLAN        = EO.ETAPA_PLAN)
                    WHERE 
                    PA.ID_PERIODO_ANUAL IN (SELECT DISTINCT PERIODO_ANUAL FROM APORTE_PAE_DISTRIBUCION)
                    GROUP BY PA.ANO, APD.APORTE_ESTRATEGICO, MPE.ETAPA_PLAN, EP.FECHA_FINAL_EVALUACION
                    ORDER BY APD.APORTE_ESTRATEGICO, PA.ANO ASC
                    
            ) EJECUCION ON (EJECUCION.ANO = PA.ANO AND EJECUCION.APORTE_ESTRATEGICO= APD.APORTE_ESTRATEGICO)
            WHERE 
            PA.ID_PERIODO_ANUAL IN (SELECT DISTINCT PERIODO_ANUAL FROM APORTE_PAE_DISTRIBUCION)
            AND EJECUCION.ETAPA_PLAN IS NOT NULL
            GROUP BY 
            ACE.ID_ACCION_ESTRATEGICA,
            ACE.CODIGO,
            ACE.DESCRIPCION,
            EJECUCION.ETAPA_PLAN
        ) ACCIONES
        
        GROUP BY 
        ACCIONES.ID_ACCION_ESTRATEGICA,
        ACCIONES.CODIGO,
        ACCIONES.DESCRIPCION,
        ACCIONES.ETAPA_PLAN
        ORDER BY 
        ACCIONES.ID_ACCION_ESTRATEGICA

) AVANCE_ACCION ON  AVANCE_ACCION.ID_ACCION_ESTRATEGICA = ACE.ID_ACCION_ESTRATEGICA
INNER JOIN ETAPA_PLAN                   EP      ON (EP.ID_ETAPA_PLAN =:etapaPlan)
WHERE 
(EM.UNIDAD_EJECUTORA = :unidadEjecutora OR :unidadEjecutora IS NULL) 
AND (PEPMP.ID_PRIORIDAD_ESTRATEGICA_PMP = :prioridadEstrategica OR :prioridadEstrategica IS NULL) 
ORDER BY PEPMP.ID_PRIORIDAD_ESTRATEGICA_PMP, OEPMP.ID_OBJETIVO_ESTRATEGICO_PMP, MPMP.CODIGO, UE.ID_UNIDAD_EJECUTORA, ACE.CODIGO