--+++++++++++++++++++++++++++++++++++++++++++++++++++++
--PASO 03: Crear FUNCIÓN
--+++++++++++++++++++++++++++++++++++++++++++++++++++++
CREATE OR REPLACE FUNCTION PPI.OBTENER_ACUMULADO_X_PERIODO_ANUAL_CONSULTA(
    --periodoAnual: parametro de ingreso
    periodoAnual IN NUMBER
)
--RETURN: tabla virtual de tipo APD_TABLE_TYPE
--RETURN ACUMULADO_TABLE_TYPE PIPELINED AS
RETURN CLOB IS

    --***************************************************************
    --VARIABLES
    --***************************************************************
    -- Almacena los años en un arreglo
    v_periodos  PERIODO_ANUAL_TABLE_TYPE := PERIODO_ANUAL_TABLE_TYPE();

    -- Variable para almacenar el año actual
    v_periodo PERIODO_ANUAL_TYPE;

    -- Variable para construir la consulta PIVOT
    v_sql CLOB;





BEGIN
    --***************************************************************
    --OBTENCIÓN DE DATOS
    --***************************************************************
    -- Ejecutar consulta del ID_PERIODO_ANUAL y  ANO para almacenarlos en arreglos para crear el PIVOT 
    FOR rec IN (SELECT PERIODO_ANUAL FROM TABLE(PPI.OBTENER_PERIODO_ANUAL_DISTRIBUCION_X_PERIODO_ANUAL(periodoAnual)) ORDER BY PERIODO_ANUAL)
    LOOP

        -- Utilizar el constructor del tipo ANO_TYPE
        v_periodo := PERIODO_ANUAL_TYPE(rec.PERIODO_ANUAL);

       -- Añadir los resultados al arreglo de años
        v_periodos.EXTEND;
        v_periodos(v_periodos.LAST) := v_periodo;



    END LOOP;


    --**************************************************************
    --CONSULTA DINÁMICA
    --**************************************************************
    v_sql := 'SELECT ';
    
    --FOR i IN 1..v_periodos.LAST LOOP
     --   v_sql := v_sql || 'NVL(EJECUCION_'|| v_periodos(i).PERIODO_ANUAL || '.EJECUCION,0) EJECUCION_' || v_periodos(i).PERIODO_ANUAL || ',';   
    --END LOOP;
    v_sql := v_sql || 'EJECUCION_' || v_periodos(1).PERIODO_ANUAL || '.APORTE_ESTRATEGICO,';
   
    v_sql := v_sql || '(';
    FOR i IN 1..v_periodos.LAST LOOP
        v_sql := v_sql || 'NVL(EJECUCION_'|| v_periodos(i).PERIODO_ANUAL || '.EJECUCION,0) ';
        IF i < v_periodos.LAST THEN
            v_sql := v_sql || ' + ';
        END IF;
    END LOOP;
    v_sql := v_sql || ') AS ACUMULADO ';
    v_sql := v_sql || 'FROM TABLE(PPI.OBTENER_EJECUCION_X_PERIODO_ANUAL(' || v_periodos(1).PERIODO_ANUAL || ')) EJECUCION_' || v_periodos(1).PERIODO_ANUAL || ' ';
    
    FOR i IN 2..v_periodos.LAST LOOP
        v_sql := v_sql || 'LEFT JOIN ';  
        v_sql := v_sql || '( ';  
        v_sql := v_sql || 'SELECT '; 
        v_sql := v_sql || 'APORTE_ESTRATEGICO, '; 
        v_sql := v_sql || 'EJECUCION '; 
        v_sql := v_sql || 'FROM TABLE(PPI.OBTENER_EJECUCION_X_PERIODO_ANUAL(' || v_periodos(i).PERIODO_ANUAL || '))'; 
        v_sql := v_sql || ') EJECUCION_' ||  v_periodos(i).PERIODO_ANUAL || ' ON EJECUCION_' || v_periodos(1).PERIODO_ANUAL || '.APORTE_ESTRATEGICO = EJECUCION_' || v_periodos(i).PERIODO_ANUAL || '.APORTE_ESTRATEGICO '; 
        v_sql := v_sql || ' '; 
    END LOOP;
    

  

    v_sql := v_sql || 'ORDER BY EJECUCION_'||v_periodos(1).PERIODO_ANUAL ||'.APORTE_ESTRATEGICO';


    RETURN v_sql;

END OBTENER_ACUMULADO_X_PERIODO_ANUAL_CONSULTA;

--+++++++++++++++++++++++++++++++++++++++++++++++++++++
--PASO 03: probar FUNCIÓN
--+++++++++++++++++++++++++++++++++++++++++++++++++++++
SET SERVEROUTPUT ON;
DECLARE
  v_query_result CLOB;
BEGIN
  v_query_result := PPI.OBTENER_ACUMULADO_X_PERIODO_ANUAL_CONSULTA(202);
  DBMS_OUTPUT.PUT_LINE('Resultado de la consulta SQL: ' || v_query_result);
END;






--+++++++++++++++++++++++++++++++++++++++++++++++++++++
--PASO 03: Crear FUNCIÓN
--+++++++++++++++++++++++++++++++++++++++++++++++++++++
CREATE OR REPLACE FUNCTION PPI.OBTENER_ACUMULADO_X_PERIODO_ANUAL(
    --periodoAnual: parametro de ingreso
    periodoAnual IN NUMBER
)
--RETURN: tabla virtual de tipo APD_TABLE_TYPE
RETURN ACUMULADO_TABLE_TYPE PIPELINED AS

    --***************************************************************
    --VARIABLES
    --***************************************************************
    -- Almacena los años en un arreglo
    v_periodos  PERIODO_ANUAL_TABLE_TYPE := PERIODO_ANUAL_TABLE_TYPE();

    -- Variable para almacenar el año actual
    v_periodo PERIODO_ANUAL_TYPE;



    -- Variable para construir la consulta PIVOT
    v_sql CLOB;

    -- Variable para almacenar el resultado de la consulta PIVOT
    v_result SYS_REFCURSOR;

     -- Variables para almacenar los valores dinámicos de las columnas del PIVOT
    v_aporte        NUMBER;
    v_acumulado     NUMBER;


BEGIN
    --***************************************************************
    --OBTENCIÓN DE DATOS
    --***************************************************************
    -- Ejecutar consulta del ID_PERIODO_ANUAL y  ANO para almacenarlos en arreglos para crear el PIVOT 
    FOR rec IN (SELECT PERIODO_ANUAL FROM TABLE(PPI.OBTENER_PERIODO_ANUAL_DISTRIBUCION_X_PERIODO_ANUAL(periodoAnual)) ORDER BY PERIODO_ANUAL)
    LOOP

        -- Utilizar el constructor del tipo ANO_TYPE
        v_periodo := PERIODO_ANUAL_TYPE(rec.PERIODO_ANUAL);

       -- Añadir los resultados al arreglo de años
        v_periodos.EXTEND;
        v_periodos(v_periodos.LAST) := v_periodo;



    END LOOP;


    --**************************************************************
    --CONSULTA DINÁMICA
    --**************************************************************
    v_sql := 'SELECT ';
    
    --FOR i IN 1..v_periodos.LAST LOOP
     --   v_sql := v_sql || 'NVL(EJECUCION_'|| v_periodos(i).PERIODO_ANUAL || '.EJECUCION,0) EJECUCION_' || v_periodos(i).PERIODO_ANUAL || ',';   
    --END LOOP;
    v_sql := v_sql || 'EJECUCION_' || v_periodos(1).PERIODO_ANUAL || '.APORTE_ESTRATEGICO,';
   
    v_sql := v_sql || '(';
    FOR i IN 1..v_periodos.LAST LOOP
        v_sql := v_sql || 'NVL(EJECUCION_'|| v_periodos(i).PERIODO_ANUAL || '.EJECUCION,0) ';
        IF i < v_periodos.LAST THEN
            v_sql := v_sql || ' + ';
        END IF;
    END LOOP;
    v_sql := v_sql || ') AS ACUMULADO ';
    v_sql := v_sql || 'FROM TABLE(PPI.OBTENER_EJECUCION_X_PERIODO_ANUAL(' || v_periodos(1).PERIODO_ANUAL || ')) EJECUCION_' || v_periodos(1).PERIODO_ANUAL || ' ';
    
    FOR i IN 2..v_periodos.LAST LOOP
        v_sql := v_sql || 'LEFT JOIN ';  
        v_sql := v_sql || '( ';  
        v_sql := v_sql || 'SELECT '; 
        v_sql := v_sql || 'APORTE_ESTRATEGICO, '; 
        v_sql := v_sql || 'EJECUCION '; 
        v_sql := v_sql || 'FROM TABLE(PPI.OBTENER_EJECUCION_X_PERIODO_ANUAL(' || v_periodos(i).PERIODO_ANUAL || '))'; 
        v_sql := v_sql || ') EJECUCION_' ||  v_periodos(i).PERIODO_ANUAL || ' ON EJECUCION_' || v_periodos(1).PERIODO_ANUAL || '.APORTE_ESTRATEGICO = EJECUCION_' || v_periodos(i).PERIODO_ANUAL || '.APORTE_ESTRATEGICO '; 
        v_sql := v_sql || ' '; 
    END LOOP;
    

  

    v_sql := v_sql || 'ORDER BY EJECUCION_'||v_periodos(1).PERIODO_ANUAL ||'.APORTE_ESTRATEGICO';


    -- Ejecutar la consulta PIVOT
    OPEN v_result FOR v_sql;

    --**************************************************************
    --RECUPERAR Y FORMATEAAR LOS DATOS
    --**************************************************************
    LOOP
       FETCH v_result INTO v_aporte,v_acumulado;
       EXIT WHEN v_result%NOTFOUND;

       PIPE ROW(ACUMULADO_TYPE(v_aporte,v_acumulado));
    END LOOP;

    CLOSE v_result;

    RETURN;

END OBTENER_ACUMULADO_X_PERIODO_ANUAL;


--+++++++++++++++++++++++++++++++++++++++++++++++++++++
--PASO 04: GRANTS
--+++++++++++++++++++++++++++++++++++++++++++++++++++++

--***********************************************
-- GRANT'S
--***********************************************
GRANT EXECUTE ON  PPI.OBTENER_ACUMULADO_X_PERIODO_ANUAL TO WWW_SIGESA,ANALISTA, ANALISTA_SIGESA;


--+++++++++++++++++++++++++++++++++++++++++++++++++++++
--PASO 05: CONSULTAR DATOS
--+++++++++++++++++++++++++++++++++++++++++++++++++++++
SELECT * FROM TABLE(PPI.OBTENER_ACUMULADO_X_PERIODO_ANUAL(:periodoAnual));


