create or replace FUNCTION     OBTENER_APD_X_PERIODDO_ANUAL(
    periodoAnual IN NUMBER
)
RETURN APD_TABLE_TYPE PIPELINED AS


    -- Almacena los años en un arreglo
    v_periodos PERIODO_ANUAL_TABLE_TYPE := PERIODO_ANUAL_TABLE_TYPE();

    -- Variable para almacenar el año actual
    v_periodo PERIODO_ANUAL_TYPE;
    
    
    -- Almacena los años en un arreglo
    v_anos ANO_TABLE_TYPE := ANO_TABLE_TYPE();

    -- Variable para almacenar el año actual
    v_ano ANO_TYPE;
    
    -- Variable para construir la consulta PIVOT
    v_sql VARCHAR2(4000);

    -- Variable para almacenar el resultado de la consulta PIVOT
    v_result SYS_REFCURSOR;

    -- Variables para almacenar los valores dinámicos de las columnas del PIVOT
    v_aporte NUMBER;
    v_valor1 NUMBER;
    v_valor2 NUMBER;
    v_valor3 NUMBER;
    v_valor4 NUMBER;
    v_valor5 NUMBER;

BEGIN
    -- Llenar el arreglo con los años
    FOR rec IN (SELECT ANO, ID_PERIODO_ANUAL
                FROM PERIODO_ANUAL
                WHERE ID_PERIODO_ANUAL IN (SELECT PERIODO_ANUAL
                                           FROM TABLE(OBTENER_PERIODOS_ANUALES_DISTRIBUCION_X_PERIDDO_ANUAL(periodoAnual)))
                ORDER BY ANO)
    LOOP
        -- Utilizar el constructor del tipo ANO_TYPE
        v_ano := ANO_TYPE(rec.ANO);
        
        -- Utilizar el constructor del tipo ANO_TYPE
        v_periodo := PERIODO_ANUAL_TYPE(rec.ID_PERIODO_ANUAL);
        
       -- Añadir los resultados al arreglo de años
        v_periodos.EXTEND;
        v_periodos(v_periodos.LAST) := v_periodo;
       
        -- Añadir los resultados al arreglo de años
        v_anos.EXTEND;
        v_anos(v_anos.LAST) := v_ano;

        -- Retornar el objeto usando PIPE ROW
        --PIPE ROW(v_periodo);
        --PIPE ROW(v_ano);
    END LOOP;
    
    
    -- Construir la consulta PIVOT dinámicamente
    v_sql := 'SELECT * FROM (SELECT APD.APORTE_ESTRATEGICO, APD.PERIODO_ANUAL, APD.DISTRIBUCION_PORCENTUAL ';
    v_sql := v_sql || 'FROM META_POA_APORTE MPAP ';
    v_sql := v_sql || 'INNER JOIN (SELECT * FROM TABLE(OBTENER_METAS_OPE_FUNCIONALES_X_PERIODO_ANUAL(' || periodoAnual || '))) METAS_FUNCIONAES ';
    v_sql := v_sql || 'ON MPAP.META_POA = METAS_FUNCIONAES.META_POA ';
    v_sql := v_sql || 'INNER JOIN APORTE_ESTRATEGICO APE ON APE.ID_APORTE_ESTRATEGICO = MPAP.APORTE_ESTRATEGICO ';
    v_sql := v_sql || 'INNER JOIN APORTE_PAE_DISTRIBUCION APD ON APD.APORTE_ESTRATEGICO = APE.ID_APORTE_ESTRATEGICO ';
    v_sql := v_sql || 'WHERE APD.PERIODO_ANUAL IN (SELECT * FROM TABLE(OBTENER_PERIODOS_ANUALES_DISTRIBUCION_X_PERIDDO_ANUAL(' || periodoAnual || ')))) ';
    v_sql := v_sql || 'PIVOT (MAX(DISTRIBUCION_PORCENTUAL) FOR PERIODO_ANUAL IN (';

    FOR i IN 1..v_anos.LAST LOOP
        v_sql := v_sql || v_periodos(i).PERIODO_ANUAL || ' as "' || v_anos(i).ANO || '"';
        IF i < v_anos.LAST THEN
            v_sql := v_sql || ', ';
        END IF;
    END LOOP;

    v_sql := v_sql || ')) ORDER BY APORTE_ESTRATEGICO';
    
    
    -- Ejecutar la consulta PIVOT
    OPEN v_result FOR v_sql;

    -- Recuperar los resultados y retornarlos
    LOOP
        FETCH v_result INTO v_aporte,v_valor1, v_valor2, v_valor3, v_valor4, v_valor5;
        EXIT WHEN v_result%NOTFOUND;

        PIPE ROW(APD_TYPE(v_aporte,v_valor1, v_valor2, v_valor3, v_valor4, v_valor5));
    END LOOP;

    CLOSE v_result;

    RETURN;

END OBTENER_APD_X_PERIODDO_ANUAL;