--********************************************
--Promedio
--********************************************
SELECT
*
FROM 
(
    SELECT 
        EP.PERIODO_ANUAL,
        MPA.APORTE_ESTRATEGICO,
        NVL(AVG(MPE.EJECUCION),0) PROMEDIO
    
    FROM
    META_POA_APORTE MPA
    INNER JOIN (
        SELECT * FROM TABLE(
            PPI.OBTENER_METAS_OPE_FUNCIONALES()
        )
    ) METAS_FUNCIONALES ON MPA.META_POA = METAS_FUNCIONALES.META_POA
    INNER JOIN META_POA_EVALUACION MPE ON (MPE.META_POA = MPA.META_POA)
    INNER JOIN ETAPA_PLAN EP ON (EP.ID_ETAPA_PLAN = MPE.ETAPA_PLAN)
    WHERE
    MPE.ETAPA_PLAN = (
        SELECT
            EP1.ID_ETAPA_PLAN
        FROM ETAPA_PLAN EP1
        WHERE
        EP1.TIPO_ETAPA = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoEtapa_evaluacion')
        AND EP1.PERIODO_ANUAL = EP.PERIODO_ANUAL
        AND EP1.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
        AND EP1.FECHA_FINAL_EVALUACION <= TRUNC(SYSDATE)
        ORDER BY
        EP1.FECHA_FINAL_EVALUACION DESC
        FETCH FIRST 1 ROW ONLY
    )
    GROUP BY EP.PERIODO_ANUAL, MPA.APORTE_ESTRATEGICO, MPE.ETAPA_PLAN
    ORDER BY 
    MPA.APORTE_ESTRATEGICO
)
PIVOT (MAX(PROMEDIO) FOR PERIODO_ANUAL IN (
    202 as "2023",222 as "2024",223 as "2025",224 as "2026",225 as "2027"
))
ORDER BY APORTE_ESTRATEGICO;




