CREATE OR REPLACE FUNCTION  PPI.OBTENER_METAS_OPE_FUNCIONALES_X_PERIODO_ANUAL(
    periodoAnual IN NUMBER
)
RETURN META_POA_TABLE_TYPE PIPELINED AS

BEGIN
    FOR rec IN (
        SELECT MPE.META_POA
        FROM META_POA_EVALUACION MPE
        INNER JOIN META_POA MP ON (MP.ID_META_POA = MPE.META_POA)
        INNER JOIN OBJETIVO_POA OP ON (OP.ID_OBJETIVO_POA = MP.OBJETIVO_POA)
        INNER JOIN PLAN_OPERATIVO PO ON (PO.ID_PLAN_OPERATIVO = OP.PLAN_OPERATIVO)
        INNER JOIN UNIDAD_EJECUTORA UE_PO ON (UE_PO.ID_UNIDAD_EJECUTORA = PO.UNIDAD_EJECUTORA)
        INNER JOIN EVALUACION_OPERATIVA EO ON (EO.PLAN_OPERATIVO = PO.ID_PLAN_OPERATIVO)
        WHERE PO.PERIODO_ANUAL = periodoAnual
        AND PO.ESTADO_FORMULACION_OPE IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE IN ('param_ppi_ppo_estadoFormulacionOpe_aprobado_unSoloNivel', 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unidad_integradora'))
        AND PO.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
        AND EO.ESTADO_EVALUACION_POA IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE IN ('param_ppi_ppo_estadoEvaluacionPOA_aprobado_unSoloNivel', 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unidad_integradora'))
        AND MPE.ETAPA_PLAN = EO.ETAPA_PLAN
        AND EO.FECHA_APROBACION = (
            SELECT 
            MAX(EO.FECHA_APROBACION) 
            FROM 
            EVALUACION_OPERATIVA EO1
            INNER JOIN PLAN_OPERATIVO PO1 ON (PO1.ID_PLAN_OPERATIVO = EO1.PLAN_OPERATIVO)
            WHERE 
            PO1.ID_PLAN_OPERATIVO = PO.ID_PLAN_OPERATIVO
            AND PO1.UNIDAD_EJECUTORA = PO.UNIDAD_EJECUTORA
        )
        ORDER BY MPE.META_POA
    ) LOOP
        PIPE ROW (META_POA_TYPE(rec.META_POA));
    END LOOP;

    RETURN;

END OBTENER_METAS_OPE_FUNCIONALES_X_PERIODO_ANUAL;