--************************************************************
--SELECT PARA OBTENER EJECUCION X PERIODO ANUAL
--************************************************************
SELECT * FROM (
    SELECT 
        DISTINCT
        APD.APORTE_ESTRATEGICO                                          APORTE_ESTRATEGICO,
        APD.PERIODO_ANUAL                                               PERIODO_ANUAL,
        APD.DISTRIBUCION_PORCENTUAL*(1 / CAN_APO.CANTIDAD_APORTES)      PROGRAMACION,
        CAN_APO.CANTIDAD_APORTES                                        CANTIDAD_APORTES_X_ACCION,
        (1 / CAN_APO.CANTIDAD_APORTES)                                  REPRESENTATIVIDAD
    FROM
    META_POA_APORTE                         MPAP
    INNER JOIN (SELECT * FROM TABLE(PPI.OBTENER_METAS_OPE_FUNCIONALES_X_PERIODO_ANUAL(:periodoAnual))) METAS_FUNCIONALES on MPAP.META_POA = METAS_FUNCIONALES.META_POA
    INNER JOIN APORTE_ESTRATEGICO           APE ON (APE.ID_APORTE_ESTRATEGICO = MPAP.APORTE_ESTRATEGICO)
    INNER JOIN APORTE_PAE_DISTRIBUCION      APD ON (APD.APORTE_ESTRATEGICO = APE.ID_APORTE_ESTRATEGICO)
    INNER JOIN ACCION_ESTRATEGICA           ACE ON (ACE.ID_ACCION_ESTRATEGICA = APE.ACCION_ESTRATEGICA)
    INNER JOIN (SELECT ACCION_ESTRATEGICA, COUNT(*) AS CANTIDAD_APORTES FROM PPI.APORTE_ESTRATEGICO GROUP BY ACCION_ESTRATEGICA) CAN_APO ON CAN_APO.ACCION_ESTRATEGICA = ACE.ID_ACCION_ESTRATEGICA
    WHERE 
    APD.PERIODO_ANUAL IN (SELECT * FROM TABLE(PPI.OBTENER_PERIODO_ANUAL_DISTRIBUCION_X_PERIODO_ANUAL(:periodoAnual))) 
)
PIVOT (
MAX(PROGRAMACION) FOR PERIODO_ANUAL IN (202 as "2023",222 as "2024",223 as "2025",224 as "2026",225 as "2027")
)
ORDER BY APORTE_ESTRATEGICO;





--************************************************************
--SELECT PARA OBTENER PROGRAMACION X PERIODO ANUAL V2
--************************************************************

SELECT 
DISTINCT
APD.APORTE_ESTRATEGICO                                          APORTE_ESTRATEGICO,
APD.DISTRIBUCION_PORCENTUAL                                     DISTRIBUCION_PORCENTUAL,
CAN_APO.CANTIDAD_APORTES                                        CANTIDAD_APORTES_X_ACCION,
(1 / CAN_APO.CANTIDAD_APORTES)                                  REPRESENTATIVIDAD,
APD.DISTRIBUCION_PORCENTUAL*(1 / CAN_APO.CANTIDAD_APORTES)      PROGRAMACION
FROM
META_POA_APORTE                         MPAP
INNER JOIN (SELECT * FROM TABLE(PPI.OBTENER_METAS_OPE_FUNCIONALES_X_PERIODO_ANUAL(:periodoAnual))) METAS_FUNCIONALES on MPAP.META_POA = METAS_FUNCIONALES.META_POA
INNER JOIN APORTE_ESTRATEGICO           APE ON (APE.ID_APORTE_ESTRATEGICO = MPAP.APORTE_ESTRATEGICO)
INNER JOIN APORTE_PAE_DISTRIBUCION      APD ON (APD.APORTE_ESTRATEGICO = APE.ID_APORTE_ESTRATEGICO)
INNER JOIN ACCION_ESTRATEGICA           ACE ON (ACE.ID_ACCION_ESTRATEGICA = APE.ACCION_ESTRATEGICA)
INNER JOIN (SELECT ACCION_ESTRATEGICA, COUNT(*) AS CANTIDAD_APORTES FROM PPI.APORTE_ESTRATEGICO GROUP BY ACCION_ESTRATEGICA) CAN_APO ON CAN_APO.ACCION_ESTRATEGICA = ACE.ID_ACCION_ESTRATEGICA
WHERE APD.PERIODO_ANUAL = :periodoAnual
ORDER BY 
APD.APORTE_ESTRATEGICO 
;