--************************************************************
-- meta_poa
--************************************************************
SELECT
    MPE.ID_META_POA_EVALUACION,
    MPE.ETAPA_PLAN,
    MPE.META_POA,
    MPE.EJECUCION,
    MPE.NOMBRE_RANGO,
    EO.ID_EVALUACION_OPERATIVA,
    PO.ID_PLAN_OPERATIVO,
    PO.CODIGO,
    PO.ESTADO_FORMULACION_OPE,
    UE_PO.ID_UNIDAD_EJECUTORA,
    UE_PO.NOMBRE,
    PO.FECHA_APROBACION
    
FROM 
META_POA_EVALUACION                 MPE
INNER JOIN META_POA                 MP      ON (MP.ID_META_POA                      =   MPE.META_POA)
INNER JOIN OBJETIVO_POA             OP      ON (OP.ID_OBJETIVO_POA                  =   MP.OBJETIVO_POA)
INNER JOIN PLAN_OPERATIVO           PO      ON (PO.ID_PLAN_OPERATIVO                =   OP.PLAN_OPERATIVO)
INNER JOIN UNIDAD_EJECUTORA         UE_PO   ON (UE_PO.ID_UNIDAD_EJECUTORA           =   PO.UNIDAD_EJECUTORA)
INNER JOIN EVALUACION_OPERATIVA     EO      ON (EO.PLAN_OPERATIVO                   =   PO.ID_PLAN_OPERATIVO AND MPE.ETAPA_PLAN = EO.ETAPA_PLAN)
INNER JOIN ETAPA_PLAN               EP      ON (EP.ID_ETAPA_PLAN                    =   EO.ETAPA_PLAN)
WHERE 
PO.PERIODO_ANUAL = :periodoAnual
AND PO.ESTADO_FORMULACION_OPE IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unidad_integradora')
AND PO.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
AND EO.ESTADO_EVALUACION_POA IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unidad_integradora')
AND MPE.ETAPA_PLAN = EO.ETAPA_PLAN

ORDER BY 
MPE.META_POA
;


AND EP.FECHA_FINAL_EVALUACION = (
    SELECT
    MAX(EP1.FECHA_FINAL_EVALUACION)
    FROM
    ETAPA_PLAN EP1
    WHERE
    EP1.TIPO_ETAPA = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoEtapa_evaluacion')
    AND EP1.PERIODO_ANUAL = :periodoAnual
    AND EP1.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
)
AND EO.FECHA_APROBACION = (
    SELECT 
    MAX(EO.FECHA_APROBACION) 
    FROM 
    EVALUACION_OPERATIVA EO1
    INNER JOIN PLAN_OPERATIVO PO1 ON (PO1.ID_PLAN_OPERATIVO = EO1.PLAN_OPERATIVO)
    WHERE 
    PO1.ID_PLAN_OPERATIVO = PO.ID_PLAN_OPERATIVO
    AND PO1.UNIDAD_EJECUTORA = PO.UNIDAD_EJECUTORA
)














--AND PO.UNIDAD_EJECUTORA = 41
--AND EO.FECHA_APROBACION = (
  --  SELECT 
   -- MAX(EO.FECHA_APROBACION) 
   -- FROM 
   -- EVALUACION_OPERATIVA EO1
   -- INNER JOIN PLAN_OPERATIVO PO1 ON (PO1.ID_PLAN_OPERATIVO = EO1.PLAN_OPERATIVO)
   -- WHERE 
   -- PO1.ID_PLAN_OPERATIVO = PO.ID_PLAN_OPERATIVO
   -- AND PO1.UNIDAD_EJECUTORA = PO.UNIDAD_EJECUTORA
--)


SELECT
MAX(EP1.FECHA_FINAL_EVALUACION)
FROM
ETAPA_PLAN EP1
WHERE
EP1.TIPO_ETAPA = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoEtapa_evaluacion')
AND EP1.PERIODO_ANUAL = :periodoAnual
AND EP1.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
ORDER BY EP1.ID_ETAPA_PLAN;


SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoEtapa_evaluacion';
SELECT
* 
FROM
TIPO_ETAPA;


select * from unidad_ejecutora;
