--************************************************************
-- FUNCION: OBTENER EL AVANCE PLP
-- VERSION: 1.0.11
--************************************************************
SELECT
    DISTINCT
    PO.PERIODO_ANUAL                            PERIODO_ANUAL,
    PLP.CODIGO                                  PLP_CODIGO,
    EJE_PLP.CODIGO                              EJE_PLP_CODIGO,
    EJE_PLP.DESCRIPCION                         EJE_PLP_DESCRIPCION,
    OBJ_PLP.CODIGO                              OBJ_PLP_CODIGO,
    OBJ_PLP.DESCRIPCION                         OBJ_PLP_DESCRIPCION,
    EJE_TRA.CODIGO                              EJE_TRA_CODIGO,
    EJE_TRA.DESCRIPCION                         EJE_TRA_DESCRIPCION,
    PRI_PMP.ID_PRIORIDAD_ESTRATEGICA_PMP        PRI_PMP_ID,
    PRI_PMP.CODIGO                              PRI_PMP_CODIGO,
    PRI_PMP.DESCRIPCION                         PRI_PMP_DESCRIPCION,
    PRIORIDAD.ACUMULADO_PRIORIDAD               ACUMULADO_PRIORIDAD,
    OBJ_PMP.CODIGO                              OBJ_PMP_CODIGO,
    OBJ_PMP.DESCRIPCION                         OBJ_PMP_DESCRIPCION,
    MPMP.ID_META_PMP                            MPMP_ID,
    MPMP.CODIGO                                 MPMP_CODIGO,
    MPMP.DESCRIPCION                            MPMP_DESCRIPCION, 
    METAPMP.ACUMULADO_METAPMP                   ACUMULADO_METAPMP,
    AAU.NOMBRE                                  AMBITO_ACCION_UNIVERITARIA,
    UE_EM.NOMBRE                                ENCARGADO_MONITOERO,
    EPES.CODIGO                                 EPES_CODIGO,
    EPES.NOMBRE                                 EPES_NOMBRE,
    TEPES.NOMBRE                                TEPES_NOMBRE,
    OPDS.CODIGO                                 OPDS_CODIGO,
    OPDS.NOMBRE                                 OPDS_NOMBRE,
    UE_PACE.NOMBRE                              UE_PACE_NOMBRE,
    ACE.ID_ACCION_ESTRATEGICA                   ACE_ID,
    ACE.CODIGO                                  ACE_CODIGO,
    ACE.DESCRIPCION                             ACE_DESCRIPCION,
    ACCION.ACUMULADO_ACCION                     ACUMULADO_ACCION,    
    UE_PAPE.NOMBRE                              UE_PAPE_NOMBRE,
    APE.CODIGO                                  APE_CODIGO,
    APE.DESCRIPCION                             APE_DESCRIPCION,
    APE.CUANTIFICACION                          CUANTIFICACION,
    APE.LINEA_BASE                              LINEA_BASE,
    FR.NOMBRE                                   FUENTE_RECURSO,
    APE.JORNADA                                 JORNADA,
    APE.ID_APORTE_ESTRATEGICO                   APE_ID,
    APORTE.CANTIDAD_APORTES_X_ACCION            CANTIDAD_APORTES_X_ACCION,
    APORTE.REPRESENTATIVIDAD                    REPRESENTATIVIDAD,
    APORTE.DISTRIBUCION_1                       DISTRIBUCION_1,
    APORTE.DISTRIBUCION_2                       DISTRIBUCION_2,
    APORTE.DISTRIBUCION_3                       DISTRIBUCION_3,
    APORTE.DISTRIBUCION_4                       DISTRIBUCION_4,
    APORTE.DISTRIBUCION_5                       DISTRIBUCION_5,
    APORTE.PROGRAMACION_1                       PROGRAMACION_1,
    APORTE.PROGRAMACION_2                       PROGRAMACION_2,
    APORTE.PROGRAMACION_3                       PROGRAMACION_3,
    APORTE.PROGRAMACION_4                       PROGRAMACION_4,
    APORTE.PROGRAMACION_5                       PROGRAMACION_5,
    APORTE.PROMEDIO_1                           PROMEDIO_1,
    APORTE.PROMEDIO_2                           PROMEDIO_2,
    APORTE.PROMEDIO_3                           PROMEDIO_3,
    APORTE.PROMEDIO_4                           PROMEDIO_4,
    APORTE.PROMEDIO_5                           PROMEDIO_5,
    APORTE.EJECUCION_1                          EJECUCION_1,
    APORTE.EJECUCION_2                          EJECUCION_2,
    APORTE.EJECUCION_3                          EJECUCION_3,
    APORTE.EJECUCION_4                          EJECUCION_4,
    APORTE.EJECUCION_5                          EJECUCION_5,
    APORTE.ACUMULADO_APORTE                     ACUMULADO_APORTE
FROM 
META_POA_EVALUACION                         MPE
INNER JOIN META_POA                         MP          ON (MP.ID_META_POA                          =   MPE.META_POA)
INNER JOIN OBJETIVO_POA                     OP          ON (OP.ID_OBJETIVO_POA                      =   MP.OBJETIVO_POA)
INNER JOIN PLAN_OPERATIVO                   PO          ON (PO.ID_PLAN_OPERATIVO                    =   OP.PLAN_OPERATIVO)
INNER JOIN UNIDAD_EJECUTORA                 UE_PO       ON (UE_PO.ID_UNIDAD_EJECUTORA               =   PO.UNIDAD_EJECUTORA)
INNER JOIN EVALUACION_OPERATIVA             EO          ON (EO.PLAN_OPERATIVO                       =   PO.ID_PLAN_OPERATIVO)
INNER JOIN META_POA_APORTE                  MPA         ON (MPA.META_POA                            =   MP.ID_META_POA)
INNER JOIN APORTE_ESTRATEGICO               APE         ON (APE.ID_APORTE_ESTRATEGICO               =   MPA.APORTE_ESTRATEGICO)
INNER JOIN PLAN_APORTE_ESTRATEGICO          PAPE        ON (PAPE.ID_PLAN_APORTE_ESTRATEGICO         =   APE.PLAN_APORTE_ESTRATEGICO)
INNER JOIN UNIDAD_EJECUTORA                 UE_PAPE     ON (UE_PAPE.ID_UNIDAD_EJECUTORA             =   PAPE.UNIDAD_EJECUTORA)
LEFT JOIN  APORTE_PAE_FUENTE_RECURSO        APAEFR      ON (APAEFR.APORTE_ESTRATEGICO               =   APE.ID_APORTE_ESTRATEGICO) --FALTAN
LEFT JOIN  FUENTE_RECURSO                   FR          ON (FR.ID_FUENTE_RECURSO                    =   APAEFR.FUENTE_RECURSO) --FALTAN
INNER JOIN ACCION_ESTRATEGICA               ACE         ON (ACE.ID_ACCION_ESTRATEGICA               =   APE.ACCION_ESTRATEGICA)
INNER JOIN PLAN_ACCION_ESTRATEGICA          PACE        ON (PACE.ID_PLAN_ACCION_ESTRATEGICA         =   ACE.PLAN_ACCION_ESTRATEGICA)
INNER JOIN UNIDAD_EJECUTORA                 UE_PACE     ON (UE_PACE.ID_UNIDAD_EJECUTORA             =   PACE.UNIDAD_EJECUTORA)
INNER JOIN META_PMP                         MPMP        ON (MPMP.ID_META_PMP                        =   ACE.META_PMP)
INNER JOIN AMBITO_ACCION_UNIVERSITARIA      AAU         ON (AAU.ID_AMBITO_ACCION_UNIVERSITARIA      =   MPMP.AMBITO_ACCION_UNIVERSITARIA)
INNER JOIN ENCARGADO_MONITOREO              EM          ON (EM.ID_ENCARGADO_MONITOREO               =   MPMP.ENCARGADO_MONITOREO)
INNER JOIN UNIDAD_EJECUTORA                 UE_EM       ON (UE_EM.ID_UNIDAD_EJECUTORA               =   EM.UNIDAD_EJECUTORA)
LEFT  JOIN META_PMP_EJE_PES                 MPEP        ON (MPEP.META_PMP                           =   MPMP.ID_META_PMP) --VACIA
LEFT  JOIN EJE_PES                          EPES        ON (EPES.ID_EJE_PES                         =   MPEP.EJE_PES)
LEFT  JOIN TIPO_EJE_PES                     TEPES       ON (TEPES.ID_TIPO_EJE_PES                   =   EPES.TIPO_EJE_PES)
LEFT  JOIN META_PMP_OBJETIVO_PDS            MPOPDS      ON (MPOPDS.META_PMP                         =   MPMP.ID_META_PMP) --VACIA
LEFT  JOIN OBJETIVO_PDS                     OPDS        ON (OPDS.ID_OBJETIVO_PDS                    =   MPOPDS.OBJETIVO_PDS)
INNER JOIN DETALLE_PMP                      DET_PMP     ON (DET_PMP.ID_DETALLE_PMP                  =   MPMP.DETALLE_PMP)
INNER JOIN PRIORIDAD_ESTRATEGICA_PMP        PRI_PMP     ON (PRI_PMP.ID_PRIORIDAD_ESTRATEGICA_PMP    =   DET_PMP.PRIORIDAD_ESTRATEGICA_PMP)
INNER JOIN OBJETIVO_ESTRATEGICO_PMP         OBJ_PMP     ON (OBJ_PMP.ID_OBJETIVO_ESTRATEGICO_PMP     =   DET_PMP.OBJETIVO_ESTRATEGICO_PMP)
INNER JOIN EJE_ESTRATEGICO_PLP              EJE_PLP     ON (EJE_PLP.ID_EJE_ESTRATEGICO_PLP          =   DET_PMP.EJE_ESTRATEGICO_LARGO_PLAZO)
INNER JOIN DETALLE_PLP                      DET_PLP     ON (DET_PLP.EJE_ESTRATEGICO_PLP             =   EJE_PLP.ID_EJE_ESTRATEGICO_PLP)   
INNER JOIN OBJETIVO_ESTRATEGICO_PLP         OBJ_PLP     ON (OBJ_PLP.ID_OBJETIVO_ESTRATEGICO_PLP     =   DET_PLP.OBJETIVO_ESTRATEGICO_PLP)
INNER JOIN DETALLE_PLP_EJE_TRANSVERSAL      DET_EJE_TRA ON (DET_EJE_TRA.DETALLE_PLP                 =   DET_PLP.ID_DETALLE_PLP)
LEFT  JOIN EJE_TRANSVERSAL_PLP              EJE_TRA     ON (EJE_TRA.ID_EJE_TRANSVERSAL_PLP          =   DET_EJE_TRA.EJE_TRANSVERSAL_PLP) --VACIA
INNER JOIN PLAN_LARGO_PLAZO                 PLP         ON (PLP.ID_PLAN_LARGO_PLAZO                 =   DET_PLP.PLAN_LARGO_PLAZO)

--METAS FUNCIONALES
INNER JOIN (SELECT *
        FROM TABLE(PPI.PPE_OBTENER_METAS_OPE_FUNCIONALES())
) METAS_FUNCIONALES on MPE.META_POA = METAS_FUNCIONALES.META_POA AND METAS_FUNCIONALES.PERIODO_ANUAL = PO.PERIODO_ANUAL

--AVANCE APORTE
INNER JOIN (SELECT *
        FROM TABLE(PPI.PPE_OBTENER_ACUMULADO_X_APORTE())
) APORTE ON APE.ID_APORTE_ESTRATEGICO = APORTE.APORTE_ESTRATEGICO

--AVANCE ACCION
INNER JOIN (SELECT *
        FROM TABLE(PPI.PPE_OBTENER_ACUMULADO_X_ACCION())
) ACCION ON ACE.ID_ACCION_ESTRATEGICA = ACCION.ACCION_ESTRATEGICA

--AVANCE METAPMP
INNER JOIN (SELECT *
        FROM TABLE(PPI.PPE_OBTENER_ACUMULADO_X_METAPMP())
) METAPMP ON MPMP.ID_META_PMP = METAPMP.META_PMP

--AVANCE PRIORIDAD
INNER JOIN (SELECT *
        FROM TABLE(PPI.PPE_OBTENER_ACUMULADO_X_PRIORIDAD())
) PRIORIDAD ON PRI_PMP.ID_PRIORIDAD_ESTRATEGICA_PMP = PRIORIDAD.PRIORIDAD_ESTRATEGICA_PMP


WHERE 

MPE.ETAPA_PLAN = (
    SELECT
        EP.ID_ETAPA_PLAN
    FROM ETAPA_PLAN EP
    WHERE
    EP.TIPO_ETAPA = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoEtapa_evaluacion')
    AND EP.PERIODO_ANUAL = PO.PERIODO_ANUAL
    AND EP.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
    AND EP.FECHA_FINAL_EVALUACION <= TRUNC(SYSDATE)
    ORDER BY
    EP.FECHA_FINAL_EVALUACION DESC
    FETCH FIRST 1 ROW ONLY

)
ORDER BY 
EJE_PLP.CODIGO,
OBJ_PLP.CODIGO,
EJE_TRA.CODIGO,
PRI_PMP.CODIGO,
OBJ_PMP.CODIGO,
MPMP.CODIGO,
AAU.NOMBRE,
UE_EM.NOMBRE,
EPES.CODIGO,
OPDS.CODIGO,
UE_PACE.NOMBRE,
ACE.CODIGO,
UE_PAPE.NOMBRE,
APE.CODIGO
;


