--************************************************************
-- FUNCION: Obtener los datos de la vista solicitada
-- VERSION: 1.0.1
--************************************************************SELECT
SELECT
    MPE.ID_META_POA_EVALUACION,
    MPE.ETAPA_PLAN,
    MPE.META_POA,
    MPE.EJECUCION,
    MPE.NOMBRE_RANGO,
    PO.ID_PLAN_OPERATIVO,
    PO.CODIGO,
    PO.ESTADO_FORMULACION_OPE,
    UE_PO.ID_UNIDAD_EJECUTORA,
    UE_PO.NOMBRE,
    PO.FECHA_APROBACION,
    EO.ID_EVALUACION_OPERATIVA
FROM 
META_POA_EVALUACION                 MPE
INNER JOIN META_POA                 MP      ON (MP.ID_META_POA                      =   MPE.META_POA)
INNER JOIN OBJETIVO_POA             OP      ON (OP.ID_OBJETIVO_POA                  =   MP.OBJETIVO_POA)
INNER JOIN PLAN_OPERATIVO           PO      ON (PO.ID_PLAN_OPERATIVO                =   OP.PLAN_OPERATIVO)
INNER JOIN UNIDAD_EJECUTORA         UE_PO   ON (UE_PO.ID_UNIDAD_EJECUTORA           =   PO.UNIDAD_EJECUTORA)
INNER JOIN EVALUACION_OPERATIVA     EO      ON (EO.PLAN_OPERATIVO                   =   PO.ID_PLAN_OPERATIVO)
WHERE 
PO.PERIODO_ANUAL = :periodoAnual
AND PO.ESTADO_FORMULACION_OPE IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unidad_integradora')
AND PO.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
AND EO.ESTADO_EVALUACION_POA IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unidad_integradora')
AND MPE.ETAPA_PLAN = EO.ETAPA_PLAN
-- FECHA MAYOR DE EVALUACION???
AND PO.FECHA_APROBACION = (
    SELECT
        MAX(PO1.FECHA_APROBACION)
    FROM 
    META_POA_EVALUACION                 MPE1
    INNER JOIN META_POA                 MP1      ON (MP1.ID_META_POA                      =   MPE1.META_POA)
    INNER JOIN OBJETIVO_POA             OP1      ON (OP1.ID_OBJETIVO_POA                  =   MP1.OBJETIVO_POA)
    INNER JOIN PLAN_OPERATIVO           PO1      ON (PO1.ID_PLAN_OPERATIVO                =   OP1.PLAN_OPERATIVO)
    INNER JOIN UNIDAD_EJECUTORA         UE_PO1   ON (UE_PO1.ID_UNIDAD_EJECUTORA           =   PO1.UNIDAD_EJECUTORA)
    INNER JOIN EVALUACION_OPERATIVA     EO1      ON (EO1.PLAN_OPERATIVO                   =   PO1.ID_PLAN_OPERATIVO)
    WHERE 
    PO1.PERIODO_ANUAL = :periodoAnual
    AND PO1.ESTADO_FORMULACION_OPE IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoFormulacionOpe_aprobado_unidad_integradora')
    AND PO1.TIPO_PLAN_OPERATIVO = (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_tipoPlanOperativo_unidad')
    AND EO1.ESTADO_EVALUACION_POA IN (SELECT VALOR FROM PARAMETRO WHERE LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unSoloNivel' OR LLAVE = 'param_ppi_ppo_estadoEvaluacionPOA_aprobado_unidad_integradora')
    AND MPE1.ETAPA_PLAN = EO1.ETAPA_PLAN
    AND PO1.UNIDAD_EJECUTORA = PO.UNIDAD_EJECUTORA
)
ORDER BY 

UE_PO.NOMBRE,
PO.CODIGO
;




SELECT * from evaluacion_operativa;
